<?php
class AL_Widget extends WP_Widget {
	public function __construct() {
		parent::__construct( 'al_widget', 'アニメの名言集', array( 'description' => 'ランダムに名言を表示' ) );
	}

	public function form( $instance ) {
?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>">タイトル:</label><br />
			<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo $instance[ 'title' ]; ?>">
		</p>
		<p>
			<label for="<?php echo $this->get_field_id( 'class' ); ?>">タイトルclass:</label><br />
			<input class="widefat" id="<?php echo $this->get_field_id( 'class' ); ?>" name="<?php echo $this->get_field_name( 'class' ); ?>" type="text" value="<?php echo $instance[ 'class' ]; ?>">
		</p>
<?php
	}

	public function update( $new, $old ) {
		$instance = wp_parse_args( $new, $old );
		return $instance;
	}

	public function widget( $args, $instance ) {
		extract( $args );

		if ( $instance['title'] != '' ) {
			if ( $instance['class'] != '' ) {
				echo '<h3 class="'.$instance['class'].'">' . $instance['title'] . '<h3>';
			} else {
				echo '<h3>' . $instance['title'] . '<h3>';
			}
		}
		$anime_lines = '';
		$cache_anime_lines = get_db_cache('cache_anime_lines', '300'); // 5分
		if ( $cache_anime_lines === false ) {
			$data = @file_get_contents('https://anime-lines.com/request/get.php?t='.time());
			$pattern = '/\<\!--\[SIDE_START\]--\>([\s\S]*)\<\!--\[SIDE_END\]--\>/';
			preg_match_all( $pattern, $data, $match );
			if ( isset($match[0][0])) {;
				$anime_lines = $match[0][0];
				set_db_cache('cache_anime_lines', $anime_lines);
			}
		} else {
			$anime_lines = $cache_anime_lines;
		}
		echo $anime_lines;

		wp_reset_postdata();
	}

    // キャッシュ取得処理
    function get_db_cache( $cache_key, $interval ) {

        $cache_key = md5($cache_key);

         // キャッシュ 保存時間を取得
        $save_time = get_option( $cache_key.'-save-time' );

        if (empty($save_time)) return false;

        if ( ( time() - $save_time ) < $interval ) {
            $cache = get_option( $cache_key.'-cache' );

            if ( $cache == '' ) {
                return false;
            } else {
                return $cache;
            }
        } else {
            return false;
        }
    }

    // キャッシュ保存
    function set_db_cache( $cache_key, $data ) {
        $cache_key = md5($cache_key);

        update_option( $cache_key.'-cache',      $data );  // データを登録
        update_option( $cache_key.'-save-time',  time() ); // 保存時間を登録
    }

}